package fr.uca.iut.clfreville2.teaiswarm

import android.content.Intent
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import androidx.recyclerview.widget.RecyclerView
import fr.uca.iut.clfreville2.teaiswarm.model.Repository

const val REPOSITORY_NAME = "repository_name"

class MainActivity : AppCompatActivity() {

    private lateinit var repositories: RecyclerView

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        repositories = findViewById(R.id.repositories_view)
        repositories.adapter = RepositoryListAdapter(
            listOf(
                "oki",
                "moshell",
                "scrabble-with-numbers",
                "vdn-tools",
                "codefirst-test",
                "iut-config",
                "Ebullition"
            ).map { Repository(it, 0) }) { repo ->
            adapterOnClick(repo)
        }
    }

    private fun adapterOnClick(repository: Repository) {
        val intent = Intent(this, RepositoryDetailActivity()::class.java)
        intent.putExtra(REPOSITORY_NAME, repository.name)
        startActivity(intent)
    }
}