package fr.uca.iut.clfreville2.teaiswarm

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import fr.uca.iut.clfreville2.teaiswarm.model.Repository

class RepositoryListAdapter(private val dataSet: List<Repository>, private val onClick: (Repository) -> Unit) :
    RecyclerView.Adapter<RepositoryListAdapter.ViewHolder>() {

    class ViewHolder(view: View, private val onClick: (Repository) -> Unit) : RecyclerView.ViewHolder(view) {
        private val repositoryNameView: TextView
        private var currentRepository: Repository? = null

        init {
            repositoryNameView = view.findViewById(R.id.repository_name)
            itemView.setOnClickListener {
                currentRepository?.let {
                    onClick(it)
                }
            }
        }

        fun bind(repository: Repository) {
            repositoryNameView.text = repository.name
            currentRepository = repository
        }
    }

    override fun onCreateViewHolder(viewGroup: ViewGroup, viewType: Int): ViewHolder {
        val view = LayoutInflater.from(viewGroup.context)
            .inflate(R.layout.repository_row_item, viewGroup, false)

        return ViewHolder(view, onClick)
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.bind(dataSet[position])
    }

    override fun getItemCount() = dataSet.size
}